//Julia-Menge zu z -> z - f(z)/f'(z)  mit f(z) = z^2+c
//Lokalisierung der Julia-Menge mit Taste <d> oder <e>, Linksklick zoomen an angeklickte Stelle
//Taste <c> wählt einen zufälligen c-Wert, Taste <n> zeichnet die verschiebenfarbigen Fatou-Gebiete
//Grad 2 und 2 Attraktoren (Fixpunkte),
//Weitere Informationen:  https://ningelgen.eu
/////////////////////////////////////////////////////////////////////////////////////////////////////////
ArrayList<Threads> threads;
Complex zNeu,zAlt,z,z0,z1,C,zA,zB,zfZaehlerNewton,zF;
ArrayList<Complex> fixpunkte;
double zR,zI;
double xU = -1.8; 
double yU = -1.8; 
double xO = 1.8;
double yO = 1.8;
double zoomFaktor=1;
double wh = xO-xU;
double x0,y0;
double laenge;
double a,b; //Fixpunkte
float aP,bP;//...und ihre Koordinaten
boolean FPzeichnen = false;
boolean Julia;//was soll gezeichnet werden
boolean Newton;
boolean farbig = false;//Unterscheidung verschiedener Orbitpunkte
boolean orbitZeichnen = false;
boolean cWerteEintragen= true; 
boolean jMSW = false;//wenn wahr, dann Skizze der Julia-Menge in schwarz/weiß
int maxiterations = 20;//Iterationsgrenze 
int orbitZeichnenAb ;
int orbitZeichnenBis;
int punktGroesse;
double massFuerUnendlich = 10000;
double E = 0.0001; //Abstand, ab dem der Orbitpunkt als zugehöriger Fixpunkt gilt
double e = E;
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
int anzahlFixpunkte = 2; //entspricht dem Grad des ganzrationalen Iterations-Polynoms
color farbe;
boolean gelbC;
float fxMax,fxMin,fyMax,fyMin;//Maxima und Minima der x bzw y Werte der Fixpunkte

void setup() {
  background(255); 
  colorMode(RGB);
  threads = new  ArrayList<Threads>();   
  fixpunkte = new ArrayList<Complex>();
  fxMin = fyMin =  10;//Minima und Maxima der Fixpunkte
  fxMax = fyMax = -10;//bzgl Realteil und Imaginärteil
  size(800, 800);
  //c-Wert
  x0=0.1D; y0=0.7D;//Julia-Menge nach DEM und BSM nur bei (1,0), (0,1), ...zu sehen! Warum?
  C = new Complex(x0,y0);
  z0 = new Complex(0,0);
  Julia = true;
  Newton = true;
  if(zoomFaktor ==1){
        fixPunkteBestimmen();
      }
  nummerThread =0;
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
               Julia, e,  Newton, jMSW, fxMin, fxMax, fyMin, fyMax, fixpunkte); 
}

/////////////////////////////////////////////////////////////////
void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, 
                   int nummer, double X0, double Y0, boolean julia, double e, boolean Newton,boolean jMSW,
                   float fxMin, float fxMax, float fyMin, float fyMax, ArrayList<Complex> fixpunkte){
  
  xU = px; yU = py;
  x0 = X0; y0 = Y0;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  Julia = julia;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,
                        Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler 
  }  
}
//////////////////////////////////////////////////////////////
void draw() {
 
  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
       if(t.gibNummer() ==0)println("fertig!");
       noLoop();
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);  
  }  
  
  if(orbitZeichnen){
      juliaIteration(z0,orbitZeichnenAb,orbitZeichnenBis );
      orbitZeichnen = false;
      farbig = false;
  }
  
  if(FPzeichnen){
    println("Fixpunkte eintragen");
    fixPunkteBestimmen();
    for(int l =0; l<anzahlFixpunkte;l++){
      fixPunktEintragen(fixpunkte.get(l));
    }
    FPzeichnen = false;
  }
  
  if(cWerteEintragen && !Julia){  
    if(gelbC){
        punktGroesse = 6;
        color f1 = color(255,255,0);
        color f2 = f1;        
        zA =  new Complex(1,0);
        zB =  new Complex(0,1);
        punkteEintragen(zA,zB,f1,f2,punktGroesse);        
    }
 }       
}
///////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){ 
  //Zunächst alle vorhandenen Punkte löschen
  fixpunkte = new ArrayList<Complex>();
  zF = (C.multiply(-1)).sqrtC();  
  fixpunkte.add(zF);
  println("Fixpunkt 1: "+fixpunkte.get(0));  
  zF = zF.multiply(-1);  
  fixpunkte.add(zF);
  println("Fixpunkt "+2+": "+fixpunkte.get(1));
}

///////////////////////////////////////////////////////////////
void fixPunktEintragen(Complex Z1 ){  
  
  strokeWeight(10); 
  stroke(0);
  a = Z1.getRealPart();
  b = Z1.getImaginaryPart();
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  point(aP,bP); 
}

///////////////////////////////////////////////////////////////
void punkteEintragen(Complex Z1, Complex Z2, color farbe1, color farbe2, int punktGroesse){
  
  strokeWeight(punktGroesse);   
  //Fixpunkt (abstoßend) auf Julia-Menge oder spezieller c-Wert
  stroke(farbe1);
  aP = map((float)Z1.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z1.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP);  
  //Fixpunkt (anziehend) in Gefangenen-Menge  oder spezieller c-Wert
  stroke(farbe2);
  aP = map((float)Z2.getRealPart(),(float)xU,(float)xO,0,width);
  bP = map((float)Z2.getImaginaryPart(),(float)yU,(float)yO,height,0); 
  point(aP,bP);
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M, int N) {//...um einen Orbit zu zeichnen ..ab ..bis
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);
  if(farbig) {
    
     farbe = color(255,255,0);
     stroke(farbe);
     
   }else{
      stroke(0,255,0);
      colorMode(RGB, 255,255,255);
    }   
  aP = map((float)a,(float)xU,(float)xO,0,width);
  bP = map((float)b,(float)yU,(float)yO,height,0); 
  strokeWeight(punktGroesse+2);
  point(aP,bP);
  
  while (n < N) {
    zNeu = FPNewton(zAlt,1);   
    laenge = zNeu.getLength();
    if (laenge > massFuerUnendlich) {
      break; 
    }
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > M){         
      aP = map((float)a,(float)xU,(float)xO,0,width);
      bP = map((float)b,(float)yU,(float)yO,height,0);
      if(farbig) stroke(farbe);
        else stroke(255,0,255);
      strokeWeight(punktGroesse);
      point(aP,bP);
    }
    zAlt = new Complex(a,b);
    n++; 
  }
  colorMode(RGB);
  return n;
 }
////////////////////////////////////////////////////////////////////
 Complex FPNewton(Complex zAlt, int M){//Newton-Iteration 
 
   for(int i =0; i< M;i++){
      zNeu = f(zAlt).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);
      zAlt = zNeu;//println(zAlt);
   }
  return zAlt;
 }
 Complex f(Complex zAlt){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(2);//z^2
      zaehler = zaehler.addC(C);//z^2+c 
      zaehler = zaehler.multiply(-1);
      return zaehler;
 }
 Complex fS(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt;//z
      nenner = nenner.multiply(2);//2z
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
////////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
         
      if (mouseButton == LEFT){ //Angeklickte Stelle zoomen
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          e = e/2;//epsilon
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, 
                        Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);  
          redraw();
        
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          orbitZeichnenBis = 20;
          punktGroesse =4;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen von Beginn");
          redraw();
         
     }else if (keyPressed == false && Julia){ //Orbit ab Element orbitZeichnenAb einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb  = 1000;
          orbitZeichnenBis = 1100;
          punktGroesse =4;   
          farbig = false;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = "+ orbitZeichnenAb);
          redraw();
     }
 }  
}
/////////////////////////////////////////////////////////////////
void keyPressed() {
 
  if (key == 'c'){
      println("Zufälligen C-Wert wählen");
      Newton = true;
      x0=random(-2,2); y0=random(-2,2);//C-Wert
      C = new Complex(x0,y0);
      if(zoomFaktor ==1){
        fixPunkteBestimmen();
      }
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0,
                    Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }
  
   if (key == 'f'){//Fixpunkte einzeichnen
     FPzeichnen=true;
     redraw();
  }
    
  if (key == 'n'){//Fatou-Gebiete farbig einzeichnen
      println("Newton-Bereiche eintragen");
      Newton = true;
      Julia = true;
      if(zoomFaktor ==1){
        fixPunkteBestimmen();
      }
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
      Newton = false;
  }   
  
  if (key == 'd'){//nur die Stellen weiß zeichnen unter denen sich die Julia-Menge gefindet
      Newton = false;
      jMSW = false; 
      println("Julia-Menge lokalisieren.");
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
  
  if (key == 'e'){//Julia-Fraktal als schwarz-weiß Bild
      Newton = false;
      jMSW = true; 
      println("Julia-Menge als schwarz-weiß Bild");
      nummerThread =0;
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
      redraw();
  }  
  
  if (key == '+'){//Iterationsgrenze erhöhen
     nummerThread =0;
     maxiterations *= 2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == '-') {//Iterationsgrenze veringern
      nummerThread =0;
      maxiterations /= 2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                    Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);  
  }
//Die folgenden Aktionen betreffen zoomen und verschieben des Bildes//////////////////////////////// 
  if (key == 'z'){//zoomen in der Mitte
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     Newton = true;
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'l'){//Bild nach links verschieben
     nummerThread =0;
     Newton = true;
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'r'){//Bild nach rechts verschieben
     nummerThread =0;
     Newton = true;
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
   if (key == 'u'){//Bild nach unten verschieben
     nummerThread =0;
     Newton = true;
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  if (key == 'o'){//bild nach oben verschieben
     nummerThread =0;
     Newton = true;
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,
                   Julia,e,Newton, jMSW,fxMin,fxMax,fyMin,fyMax,fixpunkte);
  }
  ///Bild speichern/////////////////////////////////////////////////////////////////////////
  if (key == 's') save("julia.png");
  redraw();
}
