//class MyThread extends Threads...
//////////////////////////////////////////////////////////////////////////
class Threads extends Thread {
  Complex zNeu,zAlt,C,c,z0,D,dZNeu, dZAlt;
  ArrayList<Complex> Fixpunkte;
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  int quadratMaxIt;//Anzahl der Iterationen pro Ecke des Quadrats
  int anzahlItNewton;
  int mandelIt;
  int tN;
  double massFuerUnendlich;
  double wh;
  protected boolean running = false;
  double aQMax =0;
  int farbIndex =0;
  double laenge;
  double x0 ;
  double y0 ;
  boolean julia,newton;
  double epsilon ;
  boolean juliaMengeSW;
  float fxMin, fxMax, fyMin, fyMax;

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public Threads(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, 
                 int nummer, double X0, double Y0, boolean Julia,double e, boolean Newton, boolean jMSW,
                 float FxMin, float FxMax, float FyMin, float FyMax, ArrayList<Complex> fixpunkte) {
    // benötigte Parameter
    epsilon =e;
    Fixpunkte = fixpunkte;
    julia = Julia;
    newton = Newton;
    juliaMengeSW = jMSW;
    tN = nummer; 
    wh = pwh;
    xmin=px0; ymin=py0; 
    x0 = X0; y0 = Y0;
    maxiterations = pmaxiterations;
    quadratMaxIt = 10;
    massFuerUnendlich = pmUnendlich; 
    anzahlItNewton = 10; //Anzahl der Iterationschritte zur Bestimmung der Farbe (bzw. der Fatou-Teilmenge)
    C = new Complex(X0,Y0);
    pg = createGraphics(width,height/anzahlThreads);
  }
////////////////////////////////////////////////////////////////////  
  public int gibNummer(){   //Gibt die Thread-Nummer an
    return tN;   
  }
 //////////////////////////////////////////////////////////////
public void run() {
    
    tN =this.gibNummer(); //println(tN);
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
                       
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
        //println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println(tN,xmax,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j =pg.height-1; j >= 0; j--) {  //println(pg.height);
          double x = xmin; //println(x,y);
          for (int i = 0; i < pg.width; i++) {
            z0 = new Complex(x,y);
           
            if(julia && !newton){  
              colorMode(RGB,256,256,256);
              if(juliaQuadratTest(z0,dx,dy)==color(255)){
                
                pg.pixels[i+j*pg.width] = color(255);//Julia-Fraktal
                
              }else{
                if(juliaMengeSW) pg.pixels[i+j*pg.width] = color(0);//Nur Julia-Fraktal sichtbar
              }
            }               
            //Newton-Julia-Fraktal   
            if(julia && newton) {colorMode(HSB,256,256,256);pg.pixels[i+j*pg.width] = newtonJulia(z0);}                           
            x += dx; 
          }
          y += dy;
        }      
        
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
///////////////////////////////////////////////////////////////////
color newtonJulia(Complex Z0){//Bestimmung der Farbe (bzw. des Fatou-Bereichs)
    color rueckgabe = color(0);
    zAlt = Z0;
    
    zNeu = FPNewton(zAlt); 
    zAlt = zNeu;
  
    if(zNeu.subtractC(Fixpunkte.get(0)).getLength()<0.01) rueckgabe = color(0,255,255);
     else if(zNeu.subtractC(Fixpunkte.get(1)).getLength()<0.01) rueckgabe = color(160,255,255);
     else rueckgabe = color(0);
    return rueckgabe;
}
/////////////////////////////////////////////////////////////////////
color juliaQuadratTest(Complex Z0, double Dx, double Dy) {//Test der vier Ecken eines Quadrats bzgl. Fixpunkt-Tendenz
    julia = true;
    color rueckgabe ;
    
    int fpNummer0 =-1;
    float d = 10;
    int anzahlFP = Fixpunkte.size();
    int n = 0;  
    zAlt = Z0;
    while (n < quadratMaxIt) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }
  
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer0 = i;
    } 
    
//--------------------------------------------------    
    int fpNummer1 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart());
    while (n < quadratMaxIt) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;
        n++;
    }
    
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer1 = i;
    } 
//---------------------------------------------------    
    int fpNummer2 =-1;
    n = 0;
    zAlt = new Complex(Z0.getRealPart(),Z0.getImaginaryPart()+Dy);
    while (n <quadratMaxIt) {
        zNeu = FPNewton(zAlt);   
        zAlt = zNeu;        
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer2 = i;
    } 
    
//---------------------------------------------------------   
    int fpNummer3 =-1; 
    n = 0;
    zAlt = new Complex(Z0.getRealPart()+Dx,Z0.getImaginaryPart()+Dy);
    while (n < quadratMaxIt) {
        zNeu = FPNewton(zAlt);  
        zAlt = zNeu;      
        n++;
    }
    for(int i=0; i<anzahlFP; i++){
      Complex fp = Fixpunkte.get(i);
      d= (float)(fp.subtractC(zNeu)).getLength();
      if(d<epsilon) fpNummer3 = i;
    } 
        
   //Rückgabe weiß, wenn nicht alle vier Eckpunkte zum gleichen Fixpunkt führen
    if(!(fpNummer0==fpNummer1 && fpNummer1==fpNummer2  && fpNummer2==fpNummer3))      
       rueckgabe = color(255);
       else rueckgabe = color(0); 
    
    return rueckgabe;  
 }
/////////////////////////////////////////////////////////////////////
 Complex FPNewton(Complex zAlt){//Newton-Iteration 
 
   for(int i =0; i< maxiterations;i++){
      zNeu = f(zAlt).divide(fS(zAlt));
      zNeu = zAlt.addC(zNeu);// if(tN ==7) println(i,f(zAlt),fS(zAlt),zNeu);
      zAlt = zNeu;//println(zAlt);
   }
  return zAlt;
 }
 Complex f(Complex zAlt){    //Zähler Newton-Iteration
      
      Complex zaehler = new Complex(0,0);
      zaehler = zAlt.power(2);//z^2
      zaehler = zaehler.addC(C);//z^2+c 
      zaehler = zaehler.multiply(-1);//if(tN ==7) println(zaehler,zAlt);
      return zaehler;
 }
 Complex fS(Complex zAlt){               //Nenner Newton-Iteration
      Complex nenner = new Complex(0,0);
      nenner = zAlt;//z
      nenner = nenner.multiply(2);//2z 
      // if(tN ==7) println(nenner,zAlt);
      if(nenner.getLength() < 0.000000001) nenner = new Complex(0.000001,0.000001);//Nenner 0 vermeiden
      return nenner;
 }
////////////////////////////////////////////////////////////////////
color colorize(int n) {
  colorMode(RGB);//if(n<3)println(n);
  if (n == maxiterations){
   if(julia) farbe = color(0);
      else farbe = color(0,0,100);//Farbe bei Mandelbrotmenge
     return  farbe;
  }else{   
    farbe = color(200);    
    return farbe; 
  }
 }
}
